/*---------------------------------------------------------------------------
 *
 * The global variables for lcsofm.c. April 17, 1993.
 *
 *---------------------------------------------------------------------------*/

#include "latdefs.h"


Neuron map[NMAX][NMAX]   ;       /* 2d grid Network with lateral connections */
double map_activity[NMAX][NMAX]; /* Current map_activity over network.       */
double prev_map_activity[NMAX][NMAX]; /* Old map activity                    */
double resp_to_inp[NMAX][NMAX];  /* Temporary to compute extern response     */
int    input_dimension   ;       /* The dimensionality of the input          */
double *input_vectors    ,       /* Malloced array of input vectors - the    */
       *raw_input        ;       /* dimension is determined by the variable  */
                                 /* input_dimension.                         */
Ranges *input_ranges     ;       /* Ranges for each input vector component   */
int N                    ;       /* Actual map size: NxN                     */
int lat_exc_dimension    ,
    lat_inh_dimension    ;       /* Lateral wts - excitatory & inhibitory    */
double alpha_input       ,       /* Training gain.                           */
       alpha_exc         ,       /* Gain for lateral excitation weights      */
       alpha_inh         ;       /* Gain for lateral inhibition weights      */
int    exc_rad           ;       /* Radius of lateral excitation.            */
int    inh_rad           ;       /* Not linked to lateral excitation rad     */
int    tsettle           ;       /* Iterations for activity to settle.       */
double gammaexc          ,       /* Scaling factor for lateral excitation    */
       gammainh          ;       /* Scaling factor for lateral inhibition    */
int continuing      = 0  ;       /* default: don't continue after break.     */
int displaying      = 1  ;       /* default: display                         */
int disp_rate=1          ;       /* How often to display                     */
int step_through    = 0  ;       /* Flag for stepping through bubble buildup */
int symmetric_exc_wts = 0;       /* Flag: initialize exc wts symmetrically   */
int startt=0             ,       /* Holds the starting iteration.            */
    tend                 ,       /* Last training iteration.                 */
    t                    ;       /* Loop counter                             */
double radius            ;       /* Radius in which init wts. are random.    */
double lat_exc_randomness,       /* Randomness in lateral weights like...    */
       lat_inh_randomness;       /* the 'radius' parameter for input wts.    */
long seed                ;       /* Seed for random number generator         */
char simufile[100]       ;       /* Simulation file                          */
int distribution         ;       /* Selector for input distribution          */
FILE *fp                 ;       /* Usual file pointer used by application   */
FILE *runtimefile        ;       /* To save interactive parameter changes    */
double delta,beta        ;       /* Initial values of thresholds of neurons  */
double final_delta,final_beta;   /* Upper limit for thresholds of sigmoid.   */
double alpha_delta,alpha_beta;   /* Rates of change for sigmoid thresholds   */
double scale_delta,scale_beta;   /* Scale to uniformly change upto tend      */
double act_dep_frac         ;    /* Part of sigmoid change dep on activity   */
double exc_death, inh_death ;    /* Death thresholds for lateral connections */
int border                  ;    /* No of neurons in randomly active border  */
int snapshots[MAXSNAPS]     ,    /* Store ending iteration of a snapshot.    */
    nextsnapshot            ;    /* Keeps track of current snapshot          */
int kill_phases[MAXKILLPHASES];  /* Phases of connection death               */
int nkillphases=0, killphase=0;  /* No. of killphases & current killphase.   */
int thresh_mechanism        ;    /* Thresh modification linear/act dependent */
int dynamics=0              ;    /* Continuous/discrete(1/0) dynamics        */

int Mem_Once_Alloced = False;    /* To keep track of memory allocation.      */
Blackboard blackboard       ;    /* The actual blackboard structure          */

#ifdef XWINDOW

My_Display disp          ;       /* The current display                      */
XColor colors[255]       ;       /* Colors list of the application           */
Widget top_level         ;       /* Top_level widget of the application      */
Input_history *input_list=NULL;  /* The list of input vectors                */

/* Flags set by X Application to start or continue training. The continue
 * button only sets the flag true - it does not initialize the starting
 * iteration value startt. The restart action initializes startt to 0, and
 * also reinitializes the simulation file. The stop action sets Training_Start
 * to zero so that training is stopped. Training_Done becomes true only at the
 * end of training.
 */
int Training_Start=False ,       /* Default values                           */
    Training_Done =True  ;
int maxact_i, maxact_j   ;       /* Indices of neuron with maximum activity for
				  * a given input
				  */
#endif
